/* Logger.c generated by valac 0.35.6, the Vala compiler
 * generated from Logger.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <stdio.h>


#define FEED_READER_TYPE_LOGGER (feed_reader_logger_get_type ())
#define FEED_READER_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_LOGGER, FeedReaderLogger))
#define FEED_READER_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_LOGGER, FeedReaderLoggerClass))
#define FEED_READER_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_LOGGER))
#define FEED_READER_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_LOGGER))
#define FEED_READER_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_LOGGER, FeedReaderLoggerClass))

typedef struct _FeedReaderLogger FeedReaderLogger;
typedef struct _FeedReaderLoggerClass FeedReaderLoggerClass;
typedef struct _FeedReaderLoggerPrivate FeedReaderLoggerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define FEED_READER_TYPE_LOG_MESSAGE (feed_reader_log_message_get_type ())

#define FEED_READER_TYPE_LOG_LEVEL (feed_reader_log_level_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FEED_READER_TYPE_CONSOLE_COLOR (feed_reader_console_color_get_type ())
typedef struct _Block1Data Block1Data;

struct _FeedReaderLogger {
	GObject parent_instance;
	FeedReaderLoggerPrivate * priv;
};

struct _FeedReaderLoggerClass {
	GObjectClass parent_class;
};

struct _FeedReaderLoggerPrivate {
	gint m_LogLevel;
	GFileOutputStream* m_stream;
	GeeLinkedList* m_pendingWrites;
};

typedef enum  {
	FEED_READER_LOG_MESSAGE_ERROR,
	FEED_READER_LOG_MESSAGE_WARNING,
	FEED_READER_LOG_MESSAGE_INFO,
	FEED_READER_LOG_MESSAGE_DEBUG
} FeedReaderLogMessage;

typedef enum  {
	FEED_READER_LOG_LEVEL_OFF,
	FEED_READER_LOG_LEVEL_ERROR,
	FEED_READER_LOG_LEVEL_MORE,
	FEED_READER_LOG_LEVEL_DEBUG
} FeedReaderLogLevel;

typedef enum  {
	FEED_READER_CONSOLE_COLOR_BLACK,
	FEED_READER_CONSOLE_COLOR_RED,
	FEED_READER_CONSOLE_COLOR_GREEN,
	FEED_READER_CONSOLE_COLOR_YELLOW,
	FEED_READER_CONSOLE_COLOR_BLUE,
	FEED_READER_CONSOLE_COLOR_MAGENTA,
	FEED_READER_CONSOLE_COLOR_CYAN,
	FEED_READER_CONSOLE_COLOR_WHITE
} FeedReaderConsoleColor;

struct _Block1Data {
	int _ref_count_;
	FeedReaderLogger* self;
	gchar* text;
};


static gpointer feed_reader_logger_parent_class = NULL;
static FeedReaderLogger* feed_reader_logger_m_logger;
static FeedReaderLogger* feed_reader_logger_m_logger = NULL;
static gchar* feed_reader_logger_m_fileName;
static gchar* feed_reader_logger_m_fileName = NULL;

GType feed_reader_logger_get_type (void) G_GNUC_CONST;
#define FEED_READER_LOGGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FEED_READER_TYPE_LOGGER, FeedReaderLoggerPrivate))
enum  {
	FEED_READER_LOGGER_DUMMY_PROPERTY
};
void feed_reader_logger_init (const gchar* filename);
static FeedReaderLogger* feed_reader_logger_get_default (void);
static FeedReaderLogger* feed_reader_logger_new (const gchar* filename);
static FeedReaderLogger* feed_reader_logger_construct (GType object_type, const gchar* filename);
void feed_reader_logger_error (const gchar* message);
GType feed_reader_log_message_get_type (void) G_GNUC_CONST;
static void feed_reader_logger_print (FeedReaderLogger* self, FeedReaderLogMessage level, const gchar* message);
void feed_reader_logger_warning (const gchar* message);
void feed_reader_logger_info (const gchar* message);
void feed_reader_logger_debug (const gchar* message);
GSettings* feed_reader_settings_general (void);
GType feed_reader_log_level_get_type (void) G_GNUC_CONST;
GType feed_reader_console_color_get_type (void) G_GNUC_CONST;
static void feed_reader_logger_set_color (FeedReaderLogger* self, FeedReaderConsoleColor color);
static void feed_reader_logger_write (FeedReaderLogger* self, const gchar* text);
static void feed_reader_logger_reset_color (FeedReaderLogger* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda4_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res);
static void ____lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void feed_reader_logger_finalize (GObject * obj);


void feed_reader_logger_init (const gchar* filename) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 25 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (filename != NULL);
#line 27 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = filename;
#line 27 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 27 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_free0 (feed_reader_logger_m_fileName);
#line 27 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_m_fileName = _tmp1_;
#line 145 "Logger.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "Logger.c"
}


static FeedReaderLogger* feed_reader_logger_get_default (void) {
	FeedReaderLogger* result = NULL;
	gchar* name;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	FeedReaderLogger* _tmp4_;
	FeedReaderLogger* _tmp7_;
	FeedReaderLogger* _tmp8_;
#line 32 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = g_strdup ("uninitialized");
#line 32 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	name = _tmp0_;
#line 34 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = feed_reader_logger_m_fileName;
#line 34 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (_tmp1_ != NULL) {
#line 172 "Logger.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 35 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp2_ = feed_reader_logger_m_fileName;
#line 35 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 35 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (name);
#line 35 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		name = _tmp3_;
#line 183 "Logger.c"
	}
#line 37 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp4_ = feed_reader_logger_m_logger;
#line 37 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (_tmp4_ == NULL) {
#line 189 "Logger.c"
		const gchar* _tmp5_;
		FeedReaderLogger* _tmp6_;
#line 38 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp5_ = name;
#line 38 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp6_ = feed_reader_logger_new (_tmp5_);
#line 38 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (feed_reader_logger_m_logger);
#line 38 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		feed_reader_logger_m_logger = _tmp6_;
#line 200 "Logger.c"
	}
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp7_ = feed_reader_logger_m_logger;
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	result = _tmp8_;
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_free0 (name);
#line 40 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	return result;
#line 212 "Logger.c"
}


void feed_reader_logger_error (const gchar* message) {
	FeedReaderLogger* _tmp0_;
	FeedReaderLogger* _tmp1_;
	const gchar* _tmp2_;
#line 43 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (message != NULL);
#line 45 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = feed_reader_logger_get_default ();
#line 45 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = _tmp0_;
#line 45 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = message;
#line 45 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_print (_tmp1_, FEED_READER_LOG_MESSAGE_ERROR, _tmp2_);
#line 45 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (_tmp1_);
#line 232 "Logger.c"
}


void feed_reader_logger_warning (const gchar* message) {
	FeedReaderLogger* _tmp0_;
	FeedReaderLogger* _tmp1_;
	const gchar* _tmp2_;
#line 48 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (message != NULL);
#line 50 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = feed_reader_logger_get_default ();
#line 50 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = _tmp0_;
#line 50 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = message;
#line 50 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_print (_tmp1_, FEED_READER_LOG_MESSAGE_WARNING, _tmp2_);
#line 50 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (_tmp1_);
#line 252 "Logger.c"
}


void feed_reader_logger_info (const gchar* message) {
	FeedReaderLogger* _tmp0_;
	FeedReaderLogger* _tmp1_;
	const gchar* _tmp2_;
#line 53 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (message != NULL);
#line 55 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = feed_reader_logger_get_default ();
#line 55 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = _tmp0_;
#line 55 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = message;
#line 55 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_print (_tmp1_, FEED_READER_LOG_MESSAGE_INFO, _tmp2_);
#line 55 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (_tmp1_);
#line 272 "Logger.c"
}


void feed_reader_logger_debug (const gchar* message) {
	FeedReaderLogger* _tmp0_;
	FeedReaderLogger* _tmp1_;
	const gchar* _tmp2_;
#line 58 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (message != NULL);
#line 60 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = feed_reader_logger_get_default ();
#line 60 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = _tmp0_;
#line 60 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = message;
#line 60 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_print (_tmp1_, FEED_READER_LOG_MESSAGE_DEBUG, _tmp2_);
#line 60 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (_tmp1_);
#line 292 "Logger.c"
}


static FeedReaderLogger* feed_reader_logger_construct (GType object_type, const gchar* filename) {
	FeedReaderLogger * self = NULL;
	GeeLinkedList* _tmp0_;
	gint logLevel;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* directory;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* path;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp13_;
	gboolean _tmp14_;
	GFile* file;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	gint _tmp25_;
	gint _tmp26_;
	GError * _inner_error_ = NULL;
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self = (FeedReaderLogger*) g_object_new (object_type, NULL);
#line 66 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 66 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (self->priv->m_pendingWrites);
#line 66 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self->priv->m_pendingWrites = _tmp0_;
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = feed_reader_settings_general ();
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = _tmp1_;
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp3_ = g_settings_get_enum (_tmp2_, "log-level");
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp4_ = _tmp3_;
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (_tmp2_);
#line 67 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	logLevel = _tmp4_;
#line 68 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self->priv->m_LogLevel = (gint) FEED_READER_LOG_LEVEL_DEBUG;
#line 70 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp5_ = g_get_user_data_dir ();
#line 70 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp6_ = g_build_filename (_tmp5_, "feedreader", NULL);
#line 70 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	directory = _tmp6_;
#line 71 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp7_ = directory;
#line 71 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp8_ = filename;
#line 71 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp9_ = g_strdup_printf ("%s/%s.log", _tmp7_, _tmp8_);
#line 71 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	path = _tmp9_;
#line 357 "Logger.c"
	{
		const gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp10_ = directory;
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp11_ = g_file_new_for_path (_tmp10_);
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp12_ = _tmp11_;
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_file_make_directory_with_parents (_tmp12_, NULL, &_inner_error_);
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (_tmp12_);
#line 73 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 374 "Logger.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_clear_error (&_inner_error_);
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_inner_error_ = NULL;
#line 385 "Logger.c"
	}
	__finally0:
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (path);
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (directory);
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_clear_error (&_inner_error_);
#line 72 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		return NULL;
#line 400 "Logger.c"
	}
#line 77 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp13_ = path;
#line 77 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp14_ = g_file_test (_tmp13_, G_FILE_TEST_EXISTS);
#line 77 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (_tmp14_) {
#line 408 "Logger.c"
		const gchar* _tmp15_;
#line 78 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp15_ = path;
#line 78 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_remove (_tmp15_);
#line 414 "Logger.c"
	}
#line 80 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp16_ = path;
#line 80 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp17_ = g_file_new_for_path (_tmp16_);
#line 80 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	file = _tmp17_;
#line 422 "Logger.c"
	{
		GFileOutputStream* _tmp18_;
		GFile* _tmp19_;
		GFileOutputStream* _tmp20_;
		GFileOutputStream* _tmp21_;
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp19_ = file;
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp20_ = g_file_create (_tmp19_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp18_ = _tmp20_;
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 436 "Logger.c"
			goto __catch1_g_error;
		}
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp21_ = _tmp18_;
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp18_ = NULL;
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (self->priv->m_stream);
#line 83 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		self->priv->m_stream = _tmp21_;
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (_tmp18_);
#line 449 "Logger.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		FILE* _tmp22_;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		e = _inner_error_;
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp22_ = stderr;
#line 87 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp23_ = e;
#line 87 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp24_ = _tmp23_->message;
#line 87 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		fprintf (_tmp22_, "error creating log-file: %s\n", _tmp24_);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_error_free0 (e);
#line 472 "Logger.c"
	}
	__finally1:
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (file);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (path);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (directory);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_clear_error (&_inner_error_);
#line 81 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		return NULL;
#line 489 "Logger.c"
	}
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp25_ = logLevel;
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	switch (_tmp25_) {
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_OFF:
#line 497 "Logger.c"
		{
#line 94 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_print (self, FEED_READER_LOG_MESSAGE_INFO, "Logs are deactivated!");
#line 95 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 503 "Logger.c"
		}
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_ERROR:
#line 507 "Logger.c"
		{
#line 98 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_print (self, FEED_READER_LOG_MESSAGE_INFO, "Only critical Errors are logged!");
#line 99 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 513 "Logger.c"
		}
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_MORE:
#line 517 "Logger.c"
		{
#line 102 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_print (self, FEED_READER_LOG_MESSAGE_INFO, "Errors and some general information is logged!");
#line 103 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 523 "Logger.c"
		}
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_DEBUG:
#line 527 "Logger.c"
		{
#line 106 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_print (self, FEED_READER_LOG_MESSAGE_INFO, "Everything is logged. Used to debug!");
#line 107 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 533 "Logger.c"
		}
		default:
#line 91 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		break;
#line 538 "Logger.c"
	}
#line 110 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp26_ = logLevel;
#line 110 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self->priv->m_LogLevel = _tmp26_;
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (file);
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_free0 (path);
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_free0 (directory);
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	return self;
#line 552 "Logger.c"
}


static FeedReaderLogger* feed_reader_logger_new (const gchar* filename) {
#line 64 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	return feed_reader_logger_construct (FEED_READER_TYPE_LOGGER, filename);
#line 559 "Logger.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1434 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1435 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = self;
#line 1435 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 571 "Logger.c"
}


static void feed_reader_logger_print (FeedReaderLogger* self, FeedReaderLogMessage level, const gchar* message) {
	gint _tmp0_;
	FeedReaderLogMessage _tmp3_;
	FILE* _tmp24_;
	const gchar* _tmp25_;
#line 113 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (self != NULL);
#line 113 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (message != NULL);
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = self->priv->m_LogLevel;
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	switch (_tmp0_) {
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_OFF:
#line 590 "Logger.c"
		{
#line 118 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			return;
#line 594 "Logger.c"
		}
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_ERROR:
#line 598 "Logger.c"
		{
			FeedReaderLogMessage _tmp1_;
#line 121 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp1_ = level;
#line 121 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			if (_tmp1_ != FEED_READER_LOG_MESSAGE_ERROR) {
#line 122 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
				return;
#line 607 "Logger.c"
			}
#line 123 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 611 "Logger.c"
		}
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_MORE:
#line 615 "Logger.c"
		{
			FeedReaderLogMessage _tmp2_;
#line 126 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp2_ = level;
#line 126 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			if (_tmp2_ > FEED_READER_LOG_MESSAGE_INFO) {
#line 127 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
				return;
#line 624 "Logger.c"
			}
#line 128 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 628 "Logger.c"
		}
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_LEVEL_DEBUG:
#line 632 "Logger.c"
		{
#line 131 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 636 "Logger.c"
		}
		default:
#line 115 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		break;
#line 641 "Logger.c"
	}
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp3_ = level;
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	switch (_tmp3_) {
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_MESSAGE_ERROR:
#line 649 "Logger.c"
		{
			FILE* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 137 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_set_color (self, FEED_READER_CONSOLE_COLOR_RED);
#line 138 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp4_ = stdout;
#line 138 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			fprintf (_tmp4_, "[ ERROR ] ");
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp5_ = message;
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp6_ = string_to_string (_tmp5_);
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp7_ = g_strconcat ("[ ERROR ] ", _tmp6_, "\n", NULL);
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp8_ = _tmp7_;
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_write (self, _tmp8_);
#line 139 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_g_free0 (_tmp8_);
#line 140 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 676 "Logger.c"
		}
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_MESSAGE_WARNING:
#line 680 "Logger.c"
		{
			FILE* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 143 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_set_color (self, FEED_READER_CONSOLE_COLOR_YELLOW);
#line 144 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp9_ = stdout;
#line 144 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			fprintf (_tmp9_, "[WARNING] ");
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp10_ = message;
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp11_ = string_to_string (_tmp10_);
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp12_ = g_strconcat ("[WARNING] ", _tmp11_, "\n", NULL);
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp13_ = _tmp12_;
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_write (self, _tmp13_);
#line 145 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_g_free0 (_tmp13_);
#line 146 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 707 "Logger.c"
		}
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_MESSAGE_INFO:
#line 711 "Logger.c"
		{
			FILE* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 149 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_set_color (self, FEED_READER_CONSOLE_COLOR_GREEN);
#line 150 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp14_ = stdout;
#line 150 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			fprintf (_tmp14_, "[ INFO  ] ");
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp15_ = message;
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp16_ = string_to_string (_tmp15_);
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp17_ = g_strconcat ("[ INFO  ] ", _tmp16_, "\n", NULL);
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp18_ = _tmp17_;
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_write (self, _tmp18_);
#line 151 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_g_free0 (_tmp18_);
#line 152 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 738 "Logger.c"
		}
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		case FEED_READER_LOG_MESSAGE_DEBUG:
#line 742 "Logger.c"
		{
			FILE* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 155 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_set_color (self, FEED_READER_CONSOLE_COLOR_BLUE);
#line 156 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp19_ = stdout;
#line 156 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			fprintf (_tmp19_, "[ DEBUG ] ");
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp20_ = message;
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp21_ = string_to_string (_tmp20_);
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp22_ = g_strconcat ("[ DEBUG ] ", _tmp21_, "\n", NULL);
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_tmp23_ = _tmp22_;
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			feed_reader_logger_write (self, _tmp23_);
#line 157 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			_g_free0 (_tmp23_);
#line 158 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
			break;
#line 769 "Logger.c"
		}
		default:
#line 134 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		break;
#line 774 "Logger.c"
	}
#line 161 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_reset_color (self);
#line 162 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp24_ = stdout;
#line 162 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp25_ = message;
#line 162 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	fprintf (_tmp24_, "%s\n", _tmp25_);
#line 784 "Logger.c"
}


static void feed_reader_logger_reset_color (FeedReaderLogger* self) {
	FILE* _tmp0_;
#line 165 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (self != NULL);
#line 167 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = stdout;
#line 167 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	fprintf (_tmp0_, "\x001b[0m");
#line 796 "Logger.c"
}


static void feed_reader_logger_set_color (FeedReaderLogger* self, FeedReaderConsoleColor color) {
	FeedReaderConsoleColor color_code;
	FeedReaderConsoleColor _tmp0_;
	FILE* _tmp1_;
#line 170 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (self != NULL);
#line 172 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = color;
#line 172 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	color_code = (_tmp0_ + 30) + 60;
#line 173 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = stdout;
#line 173 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	fprintf (_tmp1_, "\x001b[%dm", (gint) color_code);
#line 814 "Logger.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	return _data1_;
#line 823 "Logger.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 832 "Logger.c"
		FeedReaderLogger* self;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		self = _data1_->self;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (_data1_->text);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_object_unref0 (self);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_slice_free (Block1Data, _data1_);
#line 842 "Logger.c"
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1420 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1421 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1421 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1422 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1422 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1422 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1422 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 887 "Logger.c"
	}
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1423 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 893 "Logger.c"
}


static void ___lambda4_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res) {
	FeedReaderLogger* self;
	GeeLinkedList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GError * _inner_error_ = NULL;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self = _data1_->self;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (res != NULL);
#line 907 "Logger.c"
	{
		GFileOutputStream* _tmp0_;
		GAsyncResult* _tmp1_;
#line 189 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp0_ = self->priv->m_stream;
#line 189 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp1_ = res;
#line 189 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_output_stream_write_finish ((GOutputStream*) _tmp0_, _tmp1_, &_inner_error_);
#line 189 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 919 "Logger.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		FILE* _tmp5_;
		const gchar* _tmp6_;
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		e = _inner_error_;
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_inner_error_ = NULL;
#line 193 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp2_ = stderr;
#line 193 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp3_ = e;
#line 193 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp4_ = _tmp3_->message;
#line 193 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		fprintf (_tmp2_, "[ ERROR ] error writing log to file: %s\n", _tmp4_);
#line 194 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp5_ = stderr;
#line 194 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp6_ = _data1_->text;
#line 194 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		fprintf (_tmp5_, "[ ERROR ] %s\n", _tmp6_);
#line 195 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		feed_reader_logger_reset_color (self);
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_error_free0 (e);
#line 954 "Logger.c"
	}
	__finally2:
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_clear_error (&_inner_error_);
#line 187 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		return;
#line 965 "Logger.c"
	}
#line 198 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp7_ = self->priv->m_pendingWrites;
#line 198 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp7_);
#line 198 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp9_ = _tmp8_;
#line 198 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (_tmp9_ > 0) {
#line 975 "Logger.c"
		gchar* item;
		GeeLinkedList* _tmp10_;
		gpointer _tmp11_;
		GeeLinkedList* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 200 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp10_ = self->priv->m_pendingWrites;
#line 200 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp11_ = gee_linked_list_first (_tmp10_);
#line 200 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		item = (gchar*) _tmp11_;
#line 201 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp12_ = self->priv->m_pendingWrites;
#line 201 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp13_ = item;
#line 201 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 202 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp14_ = item;
#line 202 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		feed_reader_logger_write (self, _tmp14_);
#line 198 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_g_free0 (item);
#line 1000 "Logger.c"
	}
}


static void ____lambda4__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	___lambda4_ (self, source_object, res);
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	block1_data_unref (self);
#line 1010 "Logger.c"
}


static void feed_reader_logger_write (FeedReaderLogger* self, const gchar* text) {
	Block1Data* _data1_;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFileOutputStream* _tmp2_;
	gboolean _tmp3_;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (self != NULL);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_return_if_fail (text != NULL);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_data1_->_ref_count_ = 1;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_data1_->self = g_object_ref (self);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp0_ = text;
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_free0 (_data1_->text);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_data1_->text = _tmp1_;
#line 179 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp2_ = self->priv->m_stream;
#line 179 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_tmp3_ = g_output_stream_has_pending ((GOutputStream*) _tmp2_);
#line 179 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	if (_tmp3_) {
#line 1044 "Logger.c"
		GeeLinkedList* _tmp4_;
		const gchar* _tmp5_;
#line 181 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp4_ = self->priv->m_pendingWrites;
#line 181 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp5_ = _data1_->text;
#line 181 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp5_);
#line 1053 "Logger.c"
	} else {
		GFileOutputStream* _tmp6_;
		const gchar* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp6_ = self->priv->m_stream;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp7_ = _data1_->text;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp8_ = string_get_data (_tmp7_, &_tmp8__length1);
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp9_ = _tmp8_;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		_tmp9__length1 = _tmp8__length1;
#line 185 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
		g_output_stream_write_async ((GOutputStream*) _tmp6_, _tmp9_, (gsize) _tmp9__length1, G_PRIORITY_DEFAULT, NULL, ____lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 1073 "Logger.c"
	}
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	block1_data_unref (_data1_);
#line 176 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_data1_ = NULL;
#line 1079 "Logger.c"
}


static void feed_reader_logger_class_init (FeedReaderLoggerClass * klass) {
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	feed_reader_logger_parent_class = g_type_class_peek_parent (klass);
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	g_type_class_add_private (klass, sizeof (FeedReaderLoggerPrivate));
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	G_OBJECT_CLASS (klass)->finalize = feed_reader_logger_finalize;
#line 1090 "Logger.c"
}


static void feed_reader_logger_instance_init (FeedReaderLogger * self) {
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self->priv = FEED_READER_LOGGER_GET_PRIVATE (self);
#line 1097 "Logger.c"
}


static void feed_reader_logger_finalize (GObject * obj) {
	FeedReaderLogger * self;
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_LOGGER, FeedReaderLogger);
#line 19 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (self->priv->m_stream);
#line 20 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	_g_object_unref0 (self->priv->m_pendingWrites);
#line 16 "/builddir/build/BUILD/FeedReader-2.0.2/src/Logger.vala"
	G_OBJECT_CLASS (feed_reader_logger_parent_class)->finalize (obj);
#line 1111 "Logger.c"
}


GType feed_reader_logger_get_type (void) {
	static volatile gsize feed_reader_logger_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_logger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderLogger), 0, (GInstanceInitFunc) feed_reader_logger_instance_init, NULL };
		GType feed_reader_logger_type_id;
		feed_reader_logger_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedReaderLogger", &g_define_type_info, 0);
		g_once_init_leave (&feed_reader_logger_type_id__volatile, feed_reader_logger_type_id);
	}
	return feed_reader_logger_type_id__volatile;
}



